---
title: gcp_pubsub
type: input
status: stable
categories: ["Services","GCP"]
---

<!--
     THIS FILE IS AUTOGENERATED!

     To make changes please edit the contents of:
     lib/input/gcp_pubsub.go
-->

import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';


Consumes messages from a GCP Cloud Pub/Sub subscription.

```yaml
# Config fields, showing default values
input:
  label: ""
  gcp_pubsub:
    project: ""
    subscription: ""
    max_outstanding_messages: 1000
    max_outstanding_bytes: 1000000000
```

For information on how to set up credentials check out
[this guide](https://cloud.google.com/docs/authentication/production).

### Metadata

This input adds the following metadata fields to each message:

``` text
- gcp_pubsub_publish_time_unix
- All message attributes
```

You can access these metadata fields using
[function interpolation](/docs/configuration/interpolation#metadata).

## Fields

### `project`

The project ID of the target subscription.


Type: `string`  
Default: `""`  

### `subscription`

The target subscription ID.


Type: `string`  
Default: `""`  

### `max_outstanding_messages`

The maximum number of outstanding pending messages to be consumed at a given time.


Type: `int`  
Default: `1000`  

### `max_outstanding_bytes`

The maximum number of outstanding pending messages to be consumed measured in bytes.


Type: `int`  
Default: `1000000000`  


